ompi/errhandler/errhandler.h File Reference.TH "ompi/errhandler/errhandler.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/errhandler/errhandler.h \- 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include 'mpi.h'\fP
.br
\fC#include 'opal/class/opal_object.h'\fP
.br
\fC#include 'class/ompi_pointer_array.h'\fP
.br
\fC#include 'ompi/runtime/mpiruntime.h'\fP
.br
\fC#include 'errhandler/errhandler_predefined.h'\fP
.br
\fC#include 'errhandler/errcode-internal.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBOMPI_ERR_INIT_FINALIZE\fP(name)"
.br
.RI "\fIThis is the macro to check the state of MPI and determine whether it was properly initialized and not yet finalized. \fP"
.ti -1c
.RI "#define \fBOMPI_ERRHANDLER_INVOKE\fP(mpi_object, err_code, message)"
.br
.RI "\fIThis is the macro to invoke to directly invoke an MPI error handler. \fP"
.ti -1c
.RI "#define \fBOMPI_ERRHANDLER_CHECK\fP(rc, mpi_object, err_code, message)"
.br
.RI "\fIConditionally invoke an MPI error handler. \fP"
.ti -1c
.RI "#define \fBOMPI_ERRHANDLER_RETURN\fP(rc, mpi_object, err_code, message)"
.br
.RI "\fIConditionally invoke an MPI error handler; if there is no error, return MPI_SUCCESS. \fP"
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef void() \fBompi_errhandler_fortran_handler_fn_t\fP (MPI_Fint *, MPI_Fint *,...)"
.br
.RI "\fITypedef for all fortran errhandler functions. \fP"
.ti -1c
.RI "typedef void() \fBompi_errhandler_generic_handler_fn_t\fP (void *, int *,...)"
.br
.RI "\fITypedef for generic errhandler function. \fP"
.ti -1c
.RI "typedef enum \fBompi_errhandler_type_t\fP \fBompi_errhandler_type_t\fP"
.br
.ti -1c
.RI "typedef \fBompi_errhandler_t\fP \fBompi_errhandler_t\fP"
.br
.in -1c
.SS "Enumerations"

.in +1c
.ti -1c
.RI "enum { \fBOMPI_ERRHANDLER_NULL_FORTRAN\fP =  0, \fBOMPI_ERRORS_ARE_FATAL_FORTRAN\fP, \fBOMPI_ERRORS_RETURN_FORTRAN\fP }"
.br
.ti -1c
.RI "enum \fBompi_errhandler_type_t\fP { \fBOMPI_ERRHANDLER_TYPE_PREDEFINED\fP, \fBOMPI_ERRHANDLER_TYPE_COMM\fP, \fBOMPI_ERRHANDLER_TYPE_WIN\fP, \fBOMPI_ERRHANDLER_TYPE_FILE\fP }"
.br
.RI "\fIEnum used to describe what kind MPI object an error handler is used for. \fP"
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "int \fBompi_errhandler_init\fP (void)"
.br
.RI "\fIInitialize the error handler interface. \fP"
.ti -1c
.RI "int \fBompi_errhandler_finalize\fP (void)"
.br
.RI "\fIFinalize the error handler interface. \fP"
.ti -1c
.RI "int \fBompi_errhandler_invoke\fP (\fBompi_errhandler_t\fP *errhandler, void *mpi_object, int type, int err_code, const char *message)"
.br
.ti -1c
.RI "\fBompi_errhandler_t\fP * \fBompi_errhandler_create\fP (\fBompi_errhandler_type_t\fP object_type, \fBompi_errhandler_generic_handler_fn_t\fP *func)"
.br
.RI "\fICreate a \fBompi_errhandler_t\fP. \fP"
.ti -1c
.RI "static bool \fBompi_errhandler_is_intrinsic\fP (\fBompi_errhandler_t\fP *errhandler)"
.br
.RI "\fICheck to see if an errhandler is intrinsic. \fP"
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "OMPI_DECLSPEC \fBompi_errhandler_t\fP \fBompi_mpi_errhandler_null\fP"
.br
.RI "\fIGlobal variable for MPI_ERRHANDLER_NULL. \fP"
.ti -1c
.RI "OMPI_DECLSPEC \fBompi_errhandler_t\fP \fBompi_mpi_errors_are_fatal\fP"
.br
.RI "\fIGlobal variable for MPI_ERRORS_ARE_FATAL. \fP"
.ti -1c
.RI "OMPI_DECLSPEC \fBompi_errhandler_t\fP \fBompi_mpi_errors_return\fP"
.br
.RI "\fIGlobal variable for MPI_ERRORS_RETURN. \fP"
.ti -1c
.RI "OMPI_DECLSPEC \fBompi_pointer_array_t\fP * \fBompi_errhandler_f_to_c_table\fP"
.br
.RI "\fITable for Fortran <-> C errhandler handle conversion. \fP"
.in -1c
.SH "Detailed Description"
.PP 

.SH "Define Documentation"
.PP 
.SS "#define OMPI_ERR_INIT_FINALIZE(name)"
.PP
\fBValue:\fP
.PP
.nf
if (!ompi_mpi_initialized || ompi_mpi_finalized) { \
    ompi_mpi_errors_are_fatal_comm_handler(NULL, NULL, name); \
  }
.fi
This is the macro to check the state of MPI and determine whether it was properly initialized and not yet finalized. 
.PP
This macro directly invokes the ompi_mpi_errors_are_fatal_handler() when an error occurs because MPI_COMM_WORLD does not exist (because we're before MPI_Init() or after MPI_Finalize()). 
.SS "#define OMPI_ERRHANDLER_CHECK(rc, mpi_object, err_code, message)"
.PP
\fBValue:\fP
.PP
.nf
if (rc != OMPI_SUCCESS) { \
    int __mpi_err_code = (err_code < 0 ? (ompi_errcode_get_mpi_code(err_code)) : err_code); \
    ompi_errhandler_invoke((mpi_object)->error_handler, \
                           (mpi_object), \
                           (int) (mpi_object)->errhandler_type, \
                           (__mpi_err_code), \
                           (message)); \
    return (__mpi_err_code); \
  }
.fi
Conditionally invoke an MPI error handler. 
.PP
\fBParameters:\fP
.RS 4
\fIrc\fP The return code to check 
.br
\fImpi_object\fP The MPI object to invoke the errhandler on (a comm, win, or win) 
.br
\fIerr_code\fP The error code 
.br
\fImessage\fP Any additional message; typically the name of the MPI function that is invoking the error.
.RE
.PP
This macro will invoke the error handler if the return code is not OMPI_SUCCESS. 
.SS "#define OMPI_ERRHANDLER_INVOKE(mpi_object, err_code, message)"
.PP
\fBValue:\fP
.PP
.nf
ompi_errhandler_invoke((mpi_object)->error_handler, \
                         (mpi_object), \
                         (int)(mpi_object)->errhandler_type, \
                         (err_code < 0 ? (ompi_errcode_get_mpi_code(err_code)) : err_code), \
                         (message));
.fi
This is the macro to invoke to directly invoke an MPI error handler. 
.PP
\fBParameters:\fP
.RS 4
\fImpi_object\fP The MPI object to invoke the errhandler on (a comm, win, or win) 
.br
\fIerr_code\fP The error code 
.br
\fImessage\fP Any additional message; typically the name of the MPI function that is invoking the error.
.RE
.PP
This macro is used when you want to directly invoke the error handler. It is exactly equivalent to calling ompi_errhandler_invoke() directly, but is provided to have a parallel invocation to \fBOMPI_ERRHANDLER_CHECK()\fP and \fBOMPI_ERRHANDLER_RETURN()\fP. 
.SS "#define OMPI_ERRHANDLER_RETURN(rc, mpi_object, err_code, message)"
.PP
\fBValue:\fP
.PP
.nf
if (rc != OMPI_SUCCESS) { \
    int __mpi_err_code = (err_code < 0 ? (ompi_errcode_get_mpi_code(err_code)) : err_code); \
    ompi_errhandler_invoke((mpi_object)->error_handler, \
                           (mpi_object), \
                           (int)(mpi_object)->errhandler_type, \
                           (__mpi_err_code), \
                           (message)); \
    return (__mpi_err_code); \
  } else { \
    return MPI_SUCCESS; \
  }
.fi
Conditionally invoke an MPI error handler; if there is no error, return MPI_SUCCESS. 
.PP
\fBParameters:\fP
.RS 4
\fIrc\fP The return code to check 
.br
\fImpi_object\fP The MPI object to invoke the errhandler on (a comm, win, or win) 
.br
\fIerr_code\fP The error code 
.br
\fImessage\fP Any additional message; typically the name of the MPI function that is invoking the error.
.RE
.PP
This macro will invoke the error handler if the return code is not OMPI_SUCCESS. If the return code is OMPI_SUCCESS, then return MPI_SUCCESS. 
.SH "Function Documentation"
.PP 
.SS "\fBompi_errhandler_t\fP* ompi_errhandler_create (\fBompi_errhandler_type_t\fP object_type, \fBompi_errhandler_generic_handler_fn_t\fP * func)"
.PP
Create a \fBompi_errhandler_t\fP. 
.PP
\fBParameters:\fP
.RS 4
\fIobject_type\fP Enum of the type of MPI object 
.br
\fIfunc\fP Function pointer of the error handler
.RE
.PP
\fBReturns:\fP
.RS 4
errhandler Pointer to the ompi_errorhandler_t that will be created and returned
.RE
.PP
This function is called as the back-end of all the MPI_*_CREATE_ERRHANDLER functions. It creates a new \fBompi_errhandler_t\fP object, initializes it to the correct object type, and sets the callback function on it.
.PP
The type of the function pointer is (arbitrarily) the fortran function handler type. Since this function has to accept 4 different function pointer types (lest we have 4 different functions to create errhandlers), the fortran one was picked arbitrarily. Note that (void*) is not sufficient because at least theoretically, a sizeof(void*) may not necessarily be the same as sizeof(void(*)).
.PP
NOTE: It *always* sets the 'fortran' flag to false. Fortran wrappers for MPI_*_CREATE_ERRHANDLER are expected to reset this flag to true manually. 
.SS "int ompi_errhandler_finalize (void)"
.PP
Finalize the error handler interface. 
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS Always
.RE
.PP
Invokes from \fBompi_mpi_finalize()\fP; tears down the error handler interface, and destroys the F2C translation table. 
.SS "int ompi_errhandler_init (void)"
.PP
Initialize the error handler interface. 
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS Upon success 
.PP
OMPI_ERROR Otherwise
.RE
.PP
Invoked from \fBompi_mpi_init()\fP; sets up the error handler interface, creates the predefined MPI errorhandlers, and creates the corresopnding F2C translation table. 
.SS "static bool ompi_errhandler_is_intrinsic (\fBompi_errhandler_t\fP * errhandler)\fC [inline, static]\fP"
.PP
Check to see if an errhandler is intrinsic. 
.PP
\fBParameters:\fP
.RS 4
\fIerrhandler\fP The errhandler to check
.RE
.PP
\fBReturns:\fP
.RS 4
true If the errhandler is intrinsic 
.PP
false If the errhandler is not intrinsic
.RE
.PP
Self-explanitory. This is needed in a few top-level MPI functions; this function is provided to hide the internal structure field names. 
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
